import React,{useRef,useEffect,useState} from 'react';
import ReactDOM from 'react-dom';
import {geoMercator,geoPath,json,select} from 'd3';
import {feature} from 'topojson';
const App = () => {
  const svgRef = useRef();
	const wrapperRef = useRef();
  const svg = select(svgRef.current);
  const [geometry, setGeometry] = useState(null);

	const width = window.innerWidth;
	const height = window.innerHeight;

  
  
  const jsonIndianstate =
    'https://gist.githubusercontent.com/AnimeshN/da2cb5d197bdc0f811a2cda3eaf2e97d/raw/india_state_nfhs4.topojson';;
	const jsonIndiaDistrict = 'https://gist.githubusercontent.com/AnimeshN/7dd993301b4fb2657a221e3f5e148069/raw/india_district_nfhs4.topojson';

  
  useEffect(()=>{
  	json(jsonIndianstate).then(stateTopology =>{
    	const state = stateTopology.objects.india;
      setGeometry(feature(stateTopology,state))

  })
  },[])

  if(geometry){
  const projection = geoMercator().fitSize([width, height], geometry);
	const pathGenerator = geoPath(projection);
    svg
      .selectAll(".polygon")
      .data(geometry.features)
      .join("path").attr("class", "polygon")
      // .attr("fill", d => 'red')
      .attr("d" ,feature => pathGenerator(feature));
  }
  
  useEffect(()=>{
  	  const svg = select(svgRef.current);

  },[])
	return (
      <svg className = "svg-map" width={width} height={height} ref={svgRef} ></svg>
  )
};

ReactDOM.render(<App />, document.getElementById('root'));
